<template>
	<div class="control-userOpenDeposit wow fadeInUp">
		<form action="" @submit.prevent="submit">
			<p class="text-open">{{ $t('users.deposit_form.text') }}</p>
			<div class="box-selectInput">
				<form-select id="plan_id" v-model="form.plan_id" name="plan_id" :options="plansOptions" class="box-select"
							 :wrapper-style="{}" :span-style="{color: '#383838', padding: '16px 0 16px 15px'}" :custom-options-style="{'z-index': 1}" />
				<input type="text" placeholder="0.00" v-model.number="form.amount" :style="amountInputStyle">
				<form-select id="form_wallet_id" v-model="form.wallet_id" name="wallet_id" :options="walletsOptions" class="box-select" v-if="balances_type === 'divided'"
							 :style="{'flex-basis' : '40%'}" :span-style="{color: '#383838', padding: '16px 0 16px 15px'}" :custom-options-style="{'z-index': 1}" />
				<form-select id="form_currency_id" v-model="form.currency_id" name="currency_id" :options="currencies" class="box-select" v-else
							 :wrapper-style="{}" :span-style="{color: '#383838', padding: '16px 0 16px 15px'}" :custom-options-style="{'z-index': 1}" />
			</div>
			<button type="submit" class="save-noBg">{{ $t('users.deposit_form.submit') }}</button>
		</form>
	</div>
</template>

<script>
import {mapGetters} from "vuex";
import Currencies from "../../currencies";
import laravelValidationErrorParse from "../../mixins/laravelValidationErrorParse";

export default {
	name: "CreateDeposit",
	mixins: [laravelValidationErrorParse],
	props: ['user', 'wallets'],
	data() {
		return {
			form: {
				user_id: this.user.id,
				plan_id: undefined,
				currency_id: Currencies.default_currency_id,
				wallet_id: undefined,
				amount: 0,
			},
			plans: []
		}
	},
	computed: {
		...mapGetters([
			'balances_type',
			'axios'
		]),
		currencies() {
			let currencies = Currencies.currencies;
			let options = {};
			if (Array.isArray(currencies) && currencies.length) {
				_.map(currencies, currency => {
					options[currency.id] = currency.name;
				});
			}
			return options;
		},
		plansOptions() {
			const options = {};
			_.map(this.plans, (plan) => {
				options[plan.id] = plan.name;
			});
			return options;
		},
		walletsOptions() {
			const options = {};
			_.map(this.wallets, (wallet) => {
				let currency = Currencies.getById(wallet.payment_system.currency_id);
				console.log(wallet.payment_system.currency_id);
				console.log(currency);
				let balance = Number.parseFloat(wallet.balance).toFixed(currency.format_precision) + ` ${currency.symbol}`;
				console.log(balance);
				options[wallet.id] = `${wallet.payment_system.name} ${balance}`;
			});
			return options;
		},
		amountInputStyle() {
			if(this.balances_type === 'divided'){
				return {
					width: 'calc(25% - 15px)'
				}
			}
			return {};
		}
	},
	watch: {
		wallets(wallets){
			if(this.balances_type === 'divided'){
				this.form.wallet_id = wallets[0].id;
			}
		}
	},
	methods: {
		getPlans() {
			this.axios
				.get('plans')
				.then(resp => resp.data)
				.then(plans => this.plans = plans)
				.then(() => {
					if (!this.form.plan_id) {
						if (this.plans.length)
							this.form.plan_id = this.plans[0].id
					}
				});
		},
		submit() {
			this.axios
				.post('deposits', this.form)
				.then(resp => resp.data)
				.then(data => {
					if ('success' === data.status) {
						this.$swal('Депозит успешно открыт');
						this.$root.$emit('reload-deposits')
					} else {
						this.$swal(this.$t('ui.error'), '', 'error')
					}
				})
				.catch((error) => {
					this.displayErrorsSwal(error);
				});
		}
	},
	mounted() {
		this.getPlans();
	}
}
</script>

<style scoped lang="scss">
.control-userOpenDeposit form .box-selectInput {
	flex-basis: 50%;

	.box-select {
		flex-basis: 30%;
	}

	input {
		width: calc(30% - 15px);
	}
}

@media(max-width: 616px) {
	.control-userOpenDeposit form {
		.text-open{
			margin-bottom: 37px;
		}
		.box-selectInput {
			flex-basis: 100%;

			.box-select {
				flex-basis: 100%;
			}

			input {
				width: calc(100% - 15px);
				margin-bottom: 20px;
			}
		}
	}
}
</style>
